#include <assert.h>
#include <errno.h>
#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <unistd.h>

#define PREFIX "child: "
#define CHAR "@"
#include "eintr.h"

int unused_fd;

void sighandler(int signum)
{
/*    write(1, ".", 1); */
}

void setup(void)
{
    struct itimerval timer;

    signal(SIGALRM, sighandler);
    siginterrupt(SIGALRM, 1);

    signal(SIGINT, SIG_IGN);
    signal(SIGTERM, SIG_IGN);

    timer.it_value.tv_sec = 0;
    timer.it_value.tv_usec = 10 * 1000;
    timer.it_interval.tv_sec = 0;
    timer.it_interval.tv_usec = 10 * 1000;
    setitimer(ITIMER_REAL, &timer, NULL);
}

void tear_down(void)
{
    struct itimerval timer;

    timer.it_value.tv_sec = 0;
    timer.it_value.tv_usec = 0;
    timer.it_interval.tv_sec = 0;
    timer.it_interval.tv_usec = 0;
    setitimer(ITIMER_REAL, &timer, NULL);
}

int main(int argc, char **argv)
{
    char *filename;
    int res;
    int fd;
    long nsec;
    struct stat st;

    /* create an unused fd so open() returns fd 4 in the child process,
       whereas it returns fd 2 in the parent process, to make debug easier */
    unused_fd = dup(1);

    filename = argv[1];

    setup();

    nsec = 100 * 1000 * 1000;
    pysleep(nsec);

    fd = pyopen(filename, O_RDONLY);

    res = close(fd);
    if (res < 0) {
        perror(PREFIX "close");
        exit(1);
    }

    res = fstat(fd, &st);
    if (!res)
        print(PREFIX "close() interrupted or failed <------------------------\n");

    tear_down();

    close(unused_fd);

    return 0;
}
